{% extends 'dashboard/dashboard_content.html' %}

{% block title %}
    Past Feedback Reports
{% endblock %}

{% block rightPane %}
    {% if perms.curriculum.can_view_my_timetable %}
        <div class="row" xmlns="http://www.w3.org/1999/html">
            <div class="x_panel">
                <div class="x_title">
                    <h2>
                        <i class="icomoon icon-calendar"></i> Past Feedback Reports
                    </h2>
                    <div class="clearfix"></div>
                </div>
                <div class="row">
                    <div class="col-md-12 col-sm-12 col-xs-12">
                        <form id="submit_form" class="form-horizontal form-label-left" method="POST">{% csrf_token %}

                            <div class="form-group">
                                <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                    Department
                                </label>
                                <div class="col-md-6 col-sm-6 col-xs-12">
                                    <select name="department" id="department" class="form-control"
                                            required>
                                        <option disabled selected>-----------</option>
                                        {% for each in departmentList %}
                                            <option value="{{ each.pk }}">{{ each.acronym }}</option>
                                        {% endfor %}
                                    </select>
                                </div>
                            </div>

                            <div class="form-group">
                                <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                    Batch
                                </label>
                                <div class="col-md-6 col-sm-6 col-xs-12">
                                    <select name="batch" id="batch" class="form-control"
                                            required>
                                        <option disabled selected>-----------</option>
                                    </select>
                                </div>
                            </div>

                            <div class="form-group">
                                <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                    Semester
                                </label>
                                <div class="col-md-6 col-sm-6 col-xs-12">
                                    <select name="semester" id="semester" class="form-control"
                                            required>
                                        <option disabled selected>-----------</option>
                                    </select>
                                </div>
                            </div>

                            <div class="form-group">
                                <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                    Course
                                </label>
                                <div class="col-md-6 col-sm-6 col-xs-12">
                                    <select name="course" id="course" class="form-control"
                                            required>
                                        <option disabled selected>-----------</option>
                                    </select>
                                </div>
                            </div>
                            <br>

                            <div class="form-group">
                                <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                </label>
                                <div class="col-md-6 col-sm-6 col-xs-12">
                                    <button type="submit" class="btn1 btn-blue-grey1">Fetch Feedback
                                    </button>
                                </div>
                            </div>

                        </form>
                    </div>
                </div>

                {% if dictionary1.avail == True %}
                    <div class="col-md-offset-10">
                        <!-- Button trigger modal -->
                        <button type="button" class="btn1 btn-indigo" data-toggle="modal" data-target="#myModal">
                            Student List
                        </button>
                        <button type="button" class="btn btn-primary" id='getPdf'>
                            Generate PDF
                        </button>
                    </div>
                    <!-- Modal -->
                    <div class="modal" id="myModal" tabindex="-1" role="dialog"
                         aria-labelledby="myModalLabel1" aria-hidden="true">
                        <div class="modal-dialog" role="document">
                            <div class="modal-content">
                                <div class="modal-header">
                                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                        <span aria-hidden="true">&times;</span>
                                    </button>
                                    <h4 class="modal-title" id="myModalLabel1">Students given Feedbacks</h4>
                                </div>
                                <div class="modal-body">
                                    <h4 align="center">{{ staffCourseInstance.course }}</h4>
                                    <br>
                                    <table class="table table-hover table-striped">
                                        <thead>
                                        <tr>
                                            <th>S. No.</th>
                                            <th>Register Number</th>
                                            <th>Student Name</th>
                                        </tr>
                                        </thead>
                                        <tbody>
                                        {% for eachStudent in dictionary1.studentList %}
                                            <tr>
                                                <td>{{ forloop.counter }}</td>
                                                <td>{{ eachStudent.roll_no }}</td>
                                                <td>{{ eachStudent }}</td>
                                            </tr>
                                        {% endfor %}
                                        </tbody>
                                    </table>
                                </div>
                                <div class="modal-footer">
                                    <button type="button" class="btn1 btn1-secondary" data-dismiss="modal">Close
                                    </button>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="form-horizontal form-label-left" id="printArea">
                        <h4 style="font-weight: 500" align="center">
                            No. of Students given Feedbacks:
                            <strong style="font-weight: bolder">{{ dictionary1.studentsGivenFeedbacks }}</strong>
                        </h4>
                        <br>

                        {% for feedback in dictionary1.feedbackQuestionGradeList %}
                            <div class="col-md-12">
                                <div class="col-md-3"></div>
                                <div class="col-md-6">
                                    <table class="table table-bordered" style="table-layout: fixed">
                                        <tr>
                                            <td class="warning" colspan="2" style="width: 10%; font-weight: bolder"
                                                align="center">
                                                <strong>{{ feedback.category }}</strong></td>
                                        </tr>
                                        {% for grade in feedback.gradeList %}
                                            <tr>
                                                <td class="info" style="width: 10%">
                                                    {{ grade.grade.gradeName }}&nbsp;(<strong>{{ grade.grade.gradeShort }}</strong>)
                                                </td>
                                                <td class="success" style="word-wrap: break-word" align="center">
                                                    <strong>{{ grade.count }}</strong>
                                                </td>
                                            </tr>
                                        {% endfor %}
                                    </table>
                                </div>
                                <div class="col-md-3"></div>
                            </div>
                            <div class="col-md-12"><br><br></div>
                        {% endfor %}
                        <div class="col-md-12">
                            <div class="col-md-3"></div>
                            <div class="col-md-6">
                                <table class="table table-bordered" style="table-layout: fixed">
                                    <tr>
                                        <td class="warning" colspan="2" style="width: 10%; font-weight: bolder"
                                            align="center">
                                            <strong>CONSOLIDATED</strong>
                                        </td>
                                    </tr>
                                    {% for grade in dictionary1.feedbackList %}
                                        <tr>
                                            <td class="info" style="width: 10%">
                                                {{ grade.grade.gradeName }}&nbsp;(<strong>{{ grade.grade.gradeShort }}</strong>)
                                            </td>
                                            <td class="success" style="word-wrap: break-word" align="center">
                                                <strong>{{ grade.count }}</strong>
                                            </td>
                                        </tr>
                                    {% endfor %}
                                </table>
                            </div>
                            <div class="col-md-3"></div>
                        </div>
                    </div>
                {% elif dictionary1.avail == False %}
                    <div id="alertfield" class="x_content">
                        <div class="alert alert-warning" role="alert" align="center">
                            <h4 style="font-size: 18px"> Feedback Report is not set for
                                the course <strong>{{ staffCourseInstance.course }}</strong>
                            </h4>
                        </div>
                    </div>
                {% endif %}

            </div>
        </div>
    {% endif %}

    <form id="dummyForm" method="POST">
        {% csrf_token %}
    </form>

    <div id="printShowable" align="center" style="display: none">
        <h4 align="center">Department of {{ departmentInstance }}</h4>
        <h4 align="center">Feedback Report</h4>
        <h5 align="center">{{ staffCourseInstance.course }}</h5>
        <br>
    </div>

    <script type="text/javascript">

        //For getting CSRF token
        function getCookie(name) {
            var cookieValue = null;
            if (document.cookie && document.cookie != '') {
                var cookies = document.cookie.split(';');
                for (var i = 0; i < cookies.length; i++) {
                    var cookie = jQuery.trim(cookies[i]);
                    // Does this cookie string begin with the name we want?
                    if (cookie.substring(0, name.length + 1) == (name + '=')) {
                        cookieValue = decodeURIComponent(cookie.substring(name.length + 1));
                        break;
                    }
                }
            }
            return cookieValue;
        }

        $(document).on("change", '#department', function (e) {
            $('#batch').empty();
            $('#batch').append('<option disabled selected>' + '-----------' + '</option>');
            {% for each in batchList %}
                $('#batch').append('<option value="{{ each.id }}">{{ each }}</option>');
            {% endfor %}
        });

        $(document).on("change", '#batch', function (e) {
            var departmentPk = $('#department').val();
            var batchPk = $('#batch').val();

            $.ajax({
                type: "POST",
                data: {
                    departmentPk: departmentPk,
                    batchPk: batchPk,
                    action: 'getSemesterPlan',
                    csrfmiddlewaretoken: getCookie('csrftoken')
                },
                url: '{% url 'pastFeedbackReport' %}',
                success: function (data) {
                    if (data.semesterList.length == 0) {
                        alert('No Semester Plan');
                    }

                    $('#semester').empty();
                    $('#semester').append('<option disabled selected>' + '-----------' + '</option>');
                    var i;
                    var temp;
                    for (i = 0; (temp = data.semesterList[i]); i++) {
                        $('#semester').append('<option value="' + temp['pk'] + '">' + temp['displayText'] + '</option>');
                    }
                    $('#course').empty();
                    $('#course').append('<option disabled selected>' + '-----------' + '</option>');
                }
            });
        });


        $(document).on("change", '#semester', function (e) {
            var semesterPk = $(this).val();

            $.ajax({
                type: "POST",
                data: {
                    semesterPk: semesterPk,
                    action: 'getCourses',
                    csrfmiddlewaretoken: getCookie('csrftoken')
                },
                url: '{% url 'pastFeedbackReport' %}',
                success: function (data) {
                    if (data.courseList.length == 0) {
                        alert('No Courses');
                    }

                    $('#course').empty();
                    $('#course').append('<option disabled selected>' + '-----------' + '</option>');
                    var i;
                    var temp;
                    for (i = 0; (temp = data.courseList[i]); i++) {
                        $('#course').append('<option value="' + temp['pk'] + '">' + temp['course'] + '</option>');
                    }
                }
            });

        });


        $(document).on("submit", '#submit_form', function (e) {

            e.preventDefault();

            var department = $('#department').val();
            var batch = $('#batch').val();
            var semester = $('#semester').val();
            var course = $('#course').val();

            if (department == null) {
                alert('Select Department!');
                return;
            }

            if (batch == null) {
                alert('Select Batch!');
                return;
            }

            if (semester == null) {
                alert('Select semester!');
                return;
            }

            if (course == null) {
                alert('Select Course!');
                return;
            }

            var $hiddenInput = $('<input/>', {
                type: 'hidden',
                value: getCookie('csrftoken'),
                name: 'csrfmiddlewaretoken'
            });
            $hiddenInput.appendTo('#dummyForm');

            var $hiddenInput = $('<input/>', {
                type: 'hidden',
                value: department,
                name: 'departmentPk'
            });
            $hiddenInput.appendTo('#dummyForm');

            var $hiddenInput = $('<input/>', {
                type: 'hidden',
                value: $('#course').val(),
                name: 'staffCoursePkOnCoRequest'
            });
            $hiddenInput.appendTo('#dummyForm');

            $('#dummyForm').submit();

        });

    </script>

    <script type="text/javascript">
        $('document').ready(function () {
            {% if staffCourseInstance %}
                $('#getPdf').click(function () {
                    window.open('{% url 'pastFeedbackPdfReport' staffCoursePk=staffCourseInstance.pk %}', '_self');
                });
            {% endif %}
        });
    </script>

{% endblock %}